<template>
    <div class="w-10 flex flex-column h-auto m-auto">
        <h5 class="text-lg text-white-alpha-90">New Mail</h5>
        <InputText v-model="mail" class="p-input-panel p-0 m-0 flex justify-content-center mt-1 h-2rem" inputClass="w-full"/>
        <h5 class="mt-3 text-lg text-white-alpha-90">Password</h5>
        <Password v-model="password" :toggleMask="true" class="p-0 m-0 flex justify-content-center mt-1" inputClass="w-full" :feedback="false"/>
        <Button class="mt-5" label="Change Mail" @click="changeMail"></Button>
    </div>
</template>

<script>
import Button from 'primevue/button';
import InputText from 'primevue/inputtext';
import Password from 'primevue/password';
import { createToast } from "mosha-vue-toastify";
import VueJwtDecode from "vue-jwt-decode";

export default {
    name: 'changeUserMail',
    data() {
        return {
            mail: null,
            password: null,
        }
    },
    components: {
        Button,
        InputText,
        Password
    },
    methods: {
        changeMail() {
            if(this.mail && this.password){
                console.log(this.userEmail);
                fetch('http://localhost:3000/api/updateMail', {
                    method: 'PUT',
                    headers: {
                        'Authorization': localStorage.getItem('token'),
                        'Content-Type': 'application/json'
                    },
                    body: JSON.stringify({
                        email: this.userEmail,
                        password: this.password,
                        updateValue: this.mail
                    })
                })
                .then(response => response.json())
                .then(res => {
                    console.log(res);
                    if(res.status && res.status == 200){
                        let userData = VueJwtDecode.decode(res.data);
                        this.$store.commit('setUsername', userData.username);
                        this.$store.commit('setProfilePicture', userData.profilePicture);
                        this.$store.commit('setMail', userData.sub);
                        localStorage.setItem("token", res.data);
                        this.getUserData(res.data);
                        this.toast("Mail changed successfully", "success");
                        this.$router.go();
                    } else {
                        this.toast('Error while changing mail', 'error');
                    }
                })
            }
        },
        async getUserData(token) {
           if (localStorage.getItem("token")) {
               let userData = await VueJwtDecode.decode(token);
               await this.$store.commit("setUsername", userData.username);
               await this.$store.commit("setProfilePicture", userData.profilePicture);
               await this.$store.commit("setMail", userData.sub);
               fetch(`http://localhost:3000/api/userData`,
                 {
                   method: 'POST',
                   headers: {
                     'Content-Type': 'application/json',
                     'Access-Control-Allow-Origin': '*',
                     'Authorization': localStorage.getItem('token')
                   },
                   body: JSON.stringify({
                     mail: userData.sub
                   })
                 })
                 .then(response => response.json())
                 .then(data => {
                     if(data.status === 200){
                       this.$store.commit('getUserData', data.data);
                       let fullDateCreate = data.data.dateCreate.split(" ");
                       let hourCreate = fullDateCreate[1].split(":");
                       let datecreate = fullDateCreate[0].split("-");
                       hourCreate = hourCreate[0] + "h" + hourCreate[1];
                       datecreate = `${datecreate[2]}/${datecreate[1]}/${datecreate[0]}`;
                       this.$store.commit('setDateCreate', [datecreate, hourCreate]);
                     } else {
                       this.toast("An error was occured", 'danger');
                     }
                 })
           }
        }
    },
    computed: {
        userEmail () {
            return this.$store.state.mail;
        },
    },
    setup() {
    const toast = (message, type) => {
      createToast(message, {
        position: "top-right",
        timeout: 5000,
        type: type,
        showIcon: true,
      });
    };
    return { toast };
    
  },
}
</script>

<style scoped>

</style>